%global tag e_4_5_m_3_21_x
%global incubator_tag	e9e79d9d73ec879d0db2b909014e6e1dce7ab806

Name:    eclipse-mylyn
Summary: Eclipse Mylyn main feature
Version: 3.21.0
Release: %mkrel 1
Group:   Development/Java
License: EPL
URL: http://www.eclipse.org/mylyn

# bash fetch-eclipse-mylyn.sh
Source0: eclipse-mylyn-%{tag}-fetched-src.tar.xz
Source1: fetch-eclipse-mylyn.sh
Source6: redhat-bugzilla-custom-transitions.txt
Source7: eclipse-mylyn-%{incubator_tag}-incubator-fetched-src.tar.xz
Source8: fetch-eclipse-mylyn-incubator.sh 

Patch0: %{name}-remove-hudson-discovery.patch
Patch1: %{name}-add-apache-xmlrpc.patch
Patch2: %{name}-disable-online-tests.patch
Patch3: %{name}-merge-incubator.patch
Patch4: %{name}-bug-419133.patch
Patch5: 0001-Compile-with-Lucene-5.patch
Patch6: explicit-hamcrest-use.patch
Patch7: rome.patch
Patch8: fix-documentation.patch

BuildArch: noarch

BuildRequires: eclipse-pde >= 1:4.2.0
BuildRequires: eclipse-cdt
BuildRequires: eclipse-egit
BuildRequires: eclipse-jgit
BuildRequires: eclipse-subclipse
BuildRequires: eclipse-license
BuildRequires: eclipse-emf
BuildRequires: tycho
BuildRequires: eclipse-egit
BuildRequires: lucene
BuildRequires: lucene-queryparser
BuildRequires: maven-local
BuildRequires: apache-commons-lang >= 2.6-6
BuildRequires: apache-commons-logging
BuildRequires: apache-commons-io >= 2.3
BuildRequires: ws-commons-util >= 1.0.1-21
BuildRequires: xmlrpc-client >= 3.1.3
BuildRequires: xmlrpc-common >= 3.1.3
BuildRequires: xmlrpc-server >= 3.1.3
BuildRequires: rome >= 1.6
BuildRequires: httpcomponents-client
BuildRequires: httpcomponents-core
BuildRequires: google-gson >= 2.0.0
BuildRequires: guava
BuildRequires: xalan-j2
BuildRequires: junit
BuildRequires: hamcrest
BuildRequires: objenesis
BuildRequires: mockito
BuildRequires: maven-deploy-plugin
BuildRequires: maven-antrun-plugin
BuildRequires: maven-plugin-build-helper
BuildRequires: xml-maven-plugin
BuildRequires: tika
BuildRequires: tika-parsers
BuildRequires: jsoup
BuildRequires: jdom
BuildRequires: jdom2
BuildRequires: eclipse-ecf-runtime

Requires:      eclipse-platform

%description
Mylyn integrates task support into Eclipse. It supports offline editing
for certain task repositories and monitors work activity to hide
information that is not relevant to the current task.

%package context-java
Summary:  Mylyn Bridge:  Java Development
Requires: eclipse-jdt

%description context-java
Mylyn Task-Focused UI extensions for JDT.  Provides focusing of Java
element views and editors.

%package context-pde
Summary:  Mylyn Bridge:  Plug-in Development
Requires: eclipse-pde

%description context-pde
Mylyn Task-Focused UI extensions for PDE, Ant, Team Support and CVS.

%package context-cdt
Summary:  Mylyn Bridge:  C/C++ Development
Requires: eclipse-cdt

%description context-cdt
Mylyn Task-Focused UI extensions for CDT.  Provides focusing of C/C++
element views and editors.

%package tasks-bugzilla
Summary: Mylyn Tasks Connector: Bugzilla

%description tasks-bugzilla
Provides Task List integration, offline support and rich editing for the
open source Bugzilla bug tracker.

%package docs-wikitext
Summary: Mylyn WikiText
Obsoletes: %{name}-docs-htmltext < %{version}-%{release}
Provides:  %{name}-docs-htmltext = %{version}-%{release}

%description docs-wikitext
Enables parsing and display of lightweight markup (wiki text) and HTML text.

%package docs-epub
Summary: Mylyn EPub

%description docs-epub
The EPUB framework in Mylyn Docs offers API to create, manipulate,
read and write EPUB formatted files. 

%package  tasks-trac
Summary: Mylyn Tasks Connector: Trac

%description tasks-trac
Provides Task List integration, offline support and rich editing
for the open source Trac issue tracker.

%package  tasks-web
Summary: Mylyn Tasks Connector: Web Templates (Advanced) (Incubation)

%description tasks-web
Provides Task List integration for web-based issue trackers
and templates for example projects.

%package versions
Summary: Eclipse Mylyn Versions

%description versions
Provides a framework for accessing team providers for Eclipse Mylyn.

%package versions-git
Summary: Mylyn Versions Connector: Git

%description versions-git
Provides Git integration for Eclipse Mylyn.

%package versions-cvs
Summary: Mylyn Versions Connector: CVS

%description versions-cvs
Provides CVS integration for Eclipse Mylyn.

%package versions-subclipse
Summary: Mylyn Versions Connector: SVN

%description versions-subclipse
Provides SVN integration for Eclipse Mylyn.

%package builds
Summary: Eclipse Mylyn Builds

%description builds
Provides a common framework to interact with continuous integration
build providers using Eclipse Mylyn.

%package builds-hudson
Summary: Mylyn Builds Connector: Hudson/Jenkins
Requires: eclipse-ecf-runtime

%description builds-hudson
Support for the open source Hudson and Jenkins continuous integration servers.

%package sdk
Summary: Mylyn SDK
Requires: %{name} = %{version}-%{release}
Requires: %{name}-builds = %{version}-%{release}
Requires: %{name}-builds-hudson = %{version}-%{release}
Requires: %{name}-context-cdt = %{version}-%{release}
Requires: %{name}-context-java = %{version}-%{release}
Requires: %{name}-context-pde = %{version}-%{release}
Requires: %{name}-docs-epub = %{version}-%{release}
Requires: %{name}-docs-wikitext = %{version}-%{release}
Requires: %{name}-tasks-bugzilla = %{version}-%{release}
Requires: %{name}-tasks-trac = %{version}-%{release}
Requires: %{name}-tasks-web = %{version}-%{release}
Requires: %{name}-versions = %{version}-%{release}
Requires: %{name}-versions-cvs = %{version}-%{release}
Requires: %{name}-versions-git = %{version}-%{release}
Requires: %{name}-versions-subclipse = %{version}-%{release}

%description sdk
Sources for all Mylyn bundles.

%package tests
Summary: Mylyn test bundles
Requires: eclipse-tests
Requires: eclipse-swtbot

%description tests
All the test bundles for mylyn packages.

%prep
%setup -q -n eclipse-mylyn-%{tag}-fetched-src
tar xaf %{SOURCE7} -C org.eclipse.mylyn.tasks --strip-components=1

%patch0
%patch1
%patch2 -b .sav
%patch3 -b .sav
%patch4
pushd org.eclipse.mylyn.tasks
%patch5 -p1 -b .sav
popd
%patch6
pushd org.eclipse.mylyn.tasks
%patch7 -p1
popd

# Fix documentation URL encoding errors
%patch8
pushd org.eclipse.mylyn.docs/org.eclipse.mylyn.wikitext.help.ui
mv "help/Mylyn WikiText User Guide.textile" \
    help/Mylyn-WikiText-User-Guide.textile
mv "help/devguide/WikiText Developer Guide.textile" \
    help/devguide/WikiText-Developer-Guide.textile
popd

#remove tests that fail to compile
rm -rf org.eclipse.mylyn.commons/org.eclipse.mylyn.commons.ui.tests/src/org/eclipse/mylyn/commons/ui/ShellDragSupportTest.java
rm -rf org.eclipse.mylyn.builds/org.eclipse.mylyn.hudson.ui/src/org/eclipse/mylyn/internal/hudson/ui/HudsonDiscovery.java
rm -rf org.eclipse.mylyn.builds/org.eclipse.mylyn.hudson.ui/src/org/eclipse/mylyn/internal/hudson/ui/HudsonUiPlugin.java

# Disable plugins we can live without (they are skipped by default anyway)
%pom_remove_plugin -r :findbugs-maven-plugin
%pom_remove_plugin -r :maven-pmd-plugin
%pom_remove_plugin -r :jacoco-maven-plugin

# Disable site modules, we don't need them
for site in $(grep -l -r --include="pom.xml" eclipse-update-site .) ; do
  module=$(basename $(dirname $site)); dir=$(dirname $(dirname $site))
  %pom_disable_module $module $dir
done

# Disable modules we can't build yet
%pom_disable_module org.eclipse.mylyn.reviews .
%pom_disable_module org.eclipse.mylyn.builds.development-feature org.eclipse.mylyn.builds
sed -i -e '/\(gerrit\|reviews\)/d' org.eclipse.mylyn/org.eclipse.mylyn.tests/META-INF/MANIFEST.MF
sed -i -e '/AllGerritTests/d' -e '/AllReviewsTests/d' org.eclipse.mylyn/org.eclipse.mylyn.tests/src/org/eclipse/mylyn/tests/All*Tests.java

# Don't build artifacts that we don't ship
%pom_disable_module org.eclipse.mylyn.commons.tck-feature org.eclipse.mylyn.commons
%pom_disable_module org.eclipse.mylyn.wikitext-standalone org.eclipse.mylyn.docs
%pom_disable_module org.eclipse.mylyn.wikitext.core.maven org.eclipse.mylyn.docs

# These are not intended to be shipped by upstream, see ebz#467669 and ebz#467694 and ebz#260666
%pom_disable_module org.eclipse.mylyn.commons.identity.ui org.eclipse.mylyn.commons
%pom_disable_module org.eclipse.mylyn.docs.epub.ant.core org.eclipse.mylyn.docs
%pom_disable_module org.eclipse.mylyn.help.sdk org.eclipse.mylyn.tasks

# Correct bundle names
sed -i -e "s/org.hamcrest;/org.hamcrest.core;/g" `find . -name MANIFEST.MF`
sed -i -e "s/org.mockito;/org.mockito.mockito-core;/g"  `find . -name MANIFEST.MF`
sed -i -e "s/org.apache.ant.source;/org.apache.ant;/g"  `find . -name MANIFEST.MF`

# Use default buildtimestamp source
%pom_remove_dep :tycho-buildtimestamp-jgit org.eclipse.mylyn/org.eclipse.mylyn-parent
%pom_remove_dep :tycho-sourceref-jgit org.eclipse.mylyn/org.eclipse.mylyn-parent
sed -i -e "/<sourceReferences>/,+3d" org.eclipse.mylyn/org.eclipse.mylyn-parent/pom.xml

# Add descriptors to allow tests to run
sed -i -e "s@<addMavenDescriptor>false<@<addMavenDescriptor>true<@" org.eclipse.mylyn/org.eclipse.mylyn-parent/pom.xml

# Integrate incubator bundles
%pom_set_parent org.eclipse.mylyn.tasks:org.eclipse.mylyn.tasks-parent:%{version}-SNAPSHOT org.eclipse.mylyn.tasks/org.eclipse.mylyn.trac.wiki/pom.xml
%pom_set_parent org.eclipse.mylyn.tasks:org.eclipse.mylyn.tasks-parent:%{version}-SNAPSHOT org.eclipse.mylyn.tasks/org.eclipse.mylyn.trac.wiki-feature/pom.xml
%pom_set_parent org.eclipse.mylyn.tasks:org.eclipse.mylyn.tasks-parent:%{version}-SNAPSHOT org.eclipse.mylyn.tasks/org.eclipse.mylyn.web.tasks/pom.xml
%pom_set_parent org.eclipse.mylyn.tasks:org.eclipse.mylyn.tasks-parent:%{version}-SNAPSHOT org.eclipse.mylyn.tasks/org.eclipse.mylyn.web.tasks-feature/pom.xml
%pom_xpath_set pom:parent/pom:version "%{version}-SNAPSHOT" org.eclipse.mylyn.versions/pom.xml
%pom_xpath_set pom:parent/pom:version "%{version}-SNAPSHOT" org.eclipse.mylyn.docs/pom.xml

rm org.eclipse.mylyn.builds/org.eclipse.mylyn.hudson.ui/src/org/eclipse/mylyn/internal/hudson/ui/HudsonStartup.java

#Be more tolerant for objenesis
sed -i -e "s/1.0.0,2.0.0/1.0.0,3.0.0/g" org.eclipse.mylyn.builds/org.eclipse.mylyn.builds.tests/META-INF/MANIFEST.MF
sed -i -e "s/1.0.0,2.0.0/1.0.0,3.0.0/g" org.eclipse.mylyn.context/org.eclipse.mylyn.context.tests/META-INF/MANIFEST.MF
sed -i -e "s/1.0.0,2.0.0/1.0.0,3.0.0/g" org.eclipse.mylyn.commons/org.eclipse.mylyn.commons.ui.tests/META-INF/MANIFEST.MF
sed -i -e "s/1.0.0,2.0.0/1.0.0,3.0.0/g" org.eclipse.mylyn.tasks/org.eclipse.mylyn.tasks.core.tests/META-INF/MANIFEST.MF
sed -i -e "s/1.0.0,2.0.0/1.0.0,3.0.0/g" org.eclipse.mylyn.tasks/org.eclipse.mylyn.tasks.ui.tests/META-INF/MANIFEST.MF
sed -i -e "s/1.0.0,2.0.0/1.0.0,3.0.0/g" org.eclipse.mylyn.tasks/org.eclipse.mylyn.trac.core.tests/META-INF/MANIFEST.MF
sed -i -e "s/1.0.0,2.0.0/1.0.0,3.0.0/g" org.eclipse.mylyn.tasks/org.eclipse.mylyn.trac.ui.tests/META-INF/MANIFEST.MF
sed -i -e "s/1.0.0,2.0.0/1.0.0,3.0.0/g" org.eclipse.mylyn.docs/org.eclipse.mylyn.wikitext.core.tests/META-INF/MANIFEST.MF
sed -i -e "s/1.0.0,2.0.0/1.0.0,3.0.0/g" org.eclipse.mylyn.docs/org.eclipse.mylyn.wikitext.core.osgi.tests/META-INF/MANIFEST.MF
sed -i -e "s/1.0.0,2.0.0/1.0.0,3.0.0/g" org.eclipse.mylyn.docs/org.eclipse.mylyn.wikitext.html.tests/META-INF/MANIFEST.MF
sed -i -e "s/1.0.0,2.0.0/1.0.0,3.0.0/g" org.eclipse.mylyn.docs/org.eclipse.mylyn.wikitext.commonmark.tests/META-INF/MANIFEST.MF

#Set source level to 1.8 for bundles which require it
sed -i -e "s/JavaSE-1.7/JavaSE-1.8/g" org.eclipse.mylyn.tasks/org.eclipse.mylyn.tasks.core/META-INF/MANIFEST.MF
sed -i -e "s/JavaSE-1.7/JavaSE-1.8/g" org.eclipse.mylyn.tasks/org.eclipse.mylyn.tasks.ui/META-INF/MANIFEST.MF

sed -i -e "s|@NonNull||g" org.eclipse.mylyn.tasks/connector-bugzilla-rest/org.eclipse.mylyn.bugzilla.rest.core/src/org/eclipse/mylyn/internal/bugzilla/rest/core/RepositoryKey.java

%mvn_package "::{target,pom}::" __noinstall
%mvn_package ":*.test{s,_feature}" tests
%mvn_package ":org.eclipse.mylyn.*development" tests
%mvn_package "::jar:sources:" sdk
%mvn_package ":*.sdk{,_feature}" sdk
%mvn_package ":org.eclipse.mylyn.tests.util" sdk
%mvn_package ":org.eclipse.mylyn.{context,commons}.sdk.util" sdk
%mvn_package ":org.eclipse.mylyn.context.sdk.java" sdk
%mvn_package "org.eclipse.mylyn.builds:*hudson*" builds-hudson
%mvn_package "org.eclipse.mylyn.builds:" builds
%mvn_package "org.eclipse.mylyn.context:*cdt.mylyn*" context-cdt
%mvn_package "org.eclipse.mylyn.context:*mylyn.pde*" context-pde
%mvn_package "org.eclipse.mylyn.context:*{java_feature,java.tasks,java.ui,ide.ant,debug.ui}*" context-java
%mvn_package "org.eclipse.mylyn.docs.epub:" docs-epub
%mvn_package "org.eclipse.mylyn.docs:" docs
%mvn_package "org.eclipse.mylyn.tasks:*bugzilla*" tasks-bugzilla
%mvn_package "org.eclipse.mylyn.tasks:*trac*" tasks-trac
%mvn_package "org.eclipse.mylyn.tasks:*web.tasks*" tasks-web
%mvn_package "org.eclipse.mylyn.versions:*cvs*" versions-cvs
%mvn_package "org.eclipse.mylyn.versions:*git*" versions-git
%mvn_package "org.eclipse.mylyn.versions:*subclipse*" versions-subclipse
%mvn_package "org.eclipse.mylyn.versions:" versions
%mvn_package "org.eclipse.mylyn{,.commons,.context,.context.features,.tasks}:" commons

%build
%mvn_build -f -j -- -Ddist.qualifier="\'v\'yyyyMMdd-HHmm"

%install
%mvn_install

install %{SOURCE6} \
  %{buildroot}%{_datadir}/eclipse/droplets/mylyn-tasks-bugzilla/eclipse/redhat-bugzilla-custom-transitions.txt

%files -f .mfiles-commons

%files context-java -f .mfiles-context-java

%files context-pde -f .mfiles-context-pde

%files context-cdt -f .mfiles-context-cdt

%files tasks-bugzilla -f .mfiles-tasks-bugzilla
%{_datadir}/eclipse/droplets/mylyn-tasks-bugzilla/eclipse/redhat-bugzilla-custom-transitions.txt

%files tasks-trac -f .mfiles-tasks-trac

%files tasks-web -f .mfiles-tasks-web

%files docs-wikitext -f .mfiles-docs

%files docs-epub -f .mfiles-docs-epub

%files versions -f .mfiles-versions

%files versions-git -f .mfiles-versions-git

%files versions-cvs -f .mfiles-versions-cvs

%files versions-subclipse -f .mfiles-versions-subclipse

%files builds -f .mfiles-builds

%files builds-hudson -f .mfiles-builds-hudson

%files sdk -f .mfiles-sdk

%files tests -f .mfiles-tests




%changelog
* Sun May 21 2017 neoclust <neoclust> 3.21.0-1.mga6
+ Revision: 1103971
- New version 3.21.0

* Tue Nov 08 2016 daviddavid <daviddavid> 3.20.2-2.mga6
+ Revision: 1065926
- Change tests packaging to avoid broken symlinks in sdk package
- Move development features into tests package

* Thu Aug 11 2016 daviddavid <daviddavid> 3.20.2-1.mga6
+ Revision: 1045541
- Upgrade to 3.20.2 (sync with fc24)
- Add missing build-requires

* Sat May 14 2016 daviddavid <daviddavid> 3.19.0-2.mga6
+ Revision: 1015195
- Add Requires for eclipse-ecf-runtime for eclipse-mylyn-hudson-builds

* Sat Apr 30 2016 daviddavid <daviddavid> 3.19.0-1.mga6
+ Revision: 1008203
- Upgrade to 3.19

* Wed Mar 02 2016 neoclust <neoclust> 3.18.0-7.mga6
+ Revision: 983209
- Second rebuild of the java stack
- First rebuild of the java stack
- sync package eclipse-mylyn with fedora

